SystemOrganization addCategory: #ConfigurationOfPharoLauncher!

Object subclass: #ConfigurationOfPharoLauncher
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPharoLauncher'!

!ConfigurationOfPharoLauncher commentStamp: '<historical>' prior: 0!
A ConfigurationOfPharoLauncher is !

!ConfigurationOfPharoLauncher class methodsFor: 'development support' stamp: 'ErwanDouaille 4/27/2013 21:05'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPharoLauncher class methodsFor: 'private' stamp: 'ErwanDouaille 4/27/2013 21:05'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPharoLauncher class methodsFor: 'metadata' stamp: 'DamienCassou 1/27/2014 18:02'!
catalogChangeLog
	^ 'nothing'! !

!ConfigurationOfPharoLauncher class methodsFor: 'metadata' stamp: 'DamienCassou 1/28/2014 15:13'!
catalogContactInfo
	^ '*Damien Cassou>damien.cassou@gmail.com* is the original author and maintainer. The website is at *http://www.smalltalkhub.com/#!!/~Pharo/PharoLauncher*.

Other contributors include:
- Ben Coman
- Christophe Demarey
- Erwan Douaille
- Kilon Alios
- Tommaso Dal Sasso
- Torsten Bergmann'! !

!ConfigurationOfPharoLauncher class methodsFor: 'metadata' stamp: 'DamienCassou 1/28/2014 14:13'!
catalogDescription
	^ 'The Pharo Launcher is a cross-platform application that

- lets you manage your Pharo images (launch, rename, copy and delete);
- lets you download image templates (i.e., zip archives) from many different sources (e.g., Jenkins, files.pharo.org, and your local cache);
- lets you create new images from any template.

+https://dl.dropboxusercontent.com/u/152013/pharo-launcher-screenshot.small.png+
'! !

!ConfigurationOfPharoLauncher class methodsFor: 'metadata' stamp: 'DamienCassou 1/28/2014 15:15'!
catalogKeyClassesAndExample
	^ 'The key packages are ==PharoLauncher-Core== (the model) and ==PharoLauncher-Spec== (the GUI).

For ==PharoLauncher-Core==, the key classes are:
- ==PhLAbstractTemplate== and its subclasses ==PhLLocalTemplate== and ==PhLRemoteTemplate==. These classes model an image archive (typically a zip file) somewhere on the disk or the network.
- ==PhLAbstractTemplateGroup== and all its subclasses. These classes model a place where templates can be found: a folder somewhere on the hard disk, *http://files.pharo.org*, a Jenkins server, etc. The ==PhLCacheTemplateGroup== class is a bit special as it just provides caching for other subclasses of ==PhLAbstractTemplateGroup==.
- ==PhLImage== represents an image (a pair of a ==.image== and a ==.changes== files) on the disk.
- ==PhLDirectoryBasedImageRepository== is the class managing the user''s images (instances of ==PhLImage==).
- ==PhLTemplateGroupRepository== is the class managing the template groups (instances of ==PhLCacheTemplateGroup==).
- ==PhLCommand== and all its subclasses model all the things a user can do: creating an image from a template, renaming an image, refreshing the template groups...

For ==PharoLauncher-Spec==, the key classes are:

- ==PharoLauncher== is the main class managing the Launcher''s GUI. This class uses the *Spec framework>http://spec.st*.
- ==PhLCommandToolbar== and ==PhLCommandButton== are used to display buttons in the GUI. Each button is linked to a particular subclass of ==PhLCommand==.
- ==PhLDeploymentScript== takes care of preparing the image so that the launcher can be used as a full desktop application.'! !

!ConfigurationOfPharoLauncher class methodsFor: 'metadata' stamp: 'DamienCassou 1/28/2014 14:05'!
catalogKeywords
	^ #(launcher image template jenkins files)! !

!ConfigurationOfPharoLauncher class methodsFor: 'private' stamp: 'ErwanDouaille 4/27/2013 21:05'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPharoLauncher class methodsFor: 'private' stamp: 'ErwanDouaille 4/27/2013 21:05'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPharoLauncher class methodsFor: 'metacello tool support' stamp: 'ErwanDouaille 4/27/2013 21:05'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPharoLauncher class methodsFor: 'loading' stamp: 'DamienCassou 4/29/2013 10:34'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^ self loadBleedingEdge! !

!ConfigurationOfPharoLauncher class methodsFor: 'loading' stamp: 'ErwanDouaille 4/27/2013 21:05'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPharoLauncher class methodsFor: 'loading' stamp: 'ErwanDouaille 4/27/2013 21:05'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPharoLauncher class methodsFor: 'accessing' stamp: 'ErwanDouaille 4/27/2013 21:05'!
project

	^self new project! !

!ConfigurationOfPharoLauncher class methodsFor: 'development support' stamp: 'ErwanDouaille 4/27/2013 21:05'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'ChristopheDemarey 12/20/2013 16:48'!
baseline01: spec
	<version: '0.1-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://smalltalkhub.com/mc/Pharo/PharoLauncher/main/'.
			spec package: 'PharoLauncher-Core' with: [ spec requires: #('XML parsing' 'OSProcess' 'JSON' 'STON') ].
			spec package: 'PharoLauncher-Spec' with: [ spec requires: #('PharoLauncher-Core') ].
			spec package: 'PharoLauncher-Tests-Core' with: [ spec requires: 'PharoLauncher-Core' ].
			self externalDependencies: spec ]! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'DamienCassou 4/29/2013 10:31'!
bleedingEdge: spec
	<symbolicVersion: #bleedingEdge>
	spec for: #common version: '0.1-baseline'! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'DamienCassou 4/29/2013 10:32'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'DamienCassou 4/29/2013 10:32'!
development: spec
	<symbolicVersion: #development>
	spec for: #common version: #notDefined! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'ChristopheDemarey 12/20/2013 11:17'!
externalDependencies: spec
	spec
		project: 'XML parsing'
		with: [ 
			spec
				className: 'ConfigurationOfXMLParser';
				loads: #('Core');
				repository: 'http://www.smalltalkhub.com/mc/PharoExtras/XMLParser/main' ].
	spec
		project: 'OSProcess'
		with: [ 
			spec
				className: 'ConfigurationOfOSProcess';
				loads: #('Core');
				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
	
		spec
		project: 'Zinc'
		with: [ 
			spec
				className: 'ConfigurationOfZincHTTPComponents';
				loads: #('Zinc-HTTP');
				repository: 'http://www.squeaksource.com/ZincHTTPComponents' ].
	
	"Please change the #package:with: to a call to #project:with: as soon as there is a ConfigurationOfJSON"
	spec
		package: 'JSON'
		with: [ 
			spec
				repository: 'http://www.smalltalkhub.com/mc/NicolasPetton/JSON/main';
				file: 'JSON-ul.35' ].
			
	spec
		project: 'STON'
		with: [ 
			spec
				className: 'ConfigurationOfSton';
				versionString: #stable;
				repository: 'http://ss3.gemstone.com/ss/STON' ].
! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'ErwanDouaille 4/27/2013 21:05'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'DamienCassou 4/29/2013 10:32'!
stable: spec
	<symbolicVersion: #stable>
	spec for: #common version: #notDefined! !
